<template lang='pug'>
BaseCard.x-example(:class='{ selected: isSelected }' tabIndex='-1' :id='title')
  template(v-slot:header)
    .d-flex.justify-content-between
      div
        h5 {{ title }}
      .b-clickable(type='button' @click='setSelected')
        i.fa.fa-compress-alt(v-if='isSelected')
        i.fa.fa-expand-alt(v-else)
  li(key='0')
    slot(name='description')
    .d-flex.justify-content-end
      button.mx-1.btn.btn-sm.btn-secondary(v-if='hasSlot("code")' @click='showCode = !showCode') code
      button.mx-1.btn.btn-sm.btn-info(v-if='hasSlot("interface")' @click='showInterface = !showInterface') interface
      button.mx-1.btn.btn-sm.btn-primary(v-if='maxState !== 0'
                                         @click='stateCompo.next()') animate
  li(v-show='showInterface' key='1')
    slot(name='interface')

  li.p-0(v-show='showCode' key='2')
    PugEditor(ref="pugEditor" @change='template = $event')
      slot(name='code')

  li(key='3' v-if='hasSlot("code")')
    StateComponent(ref='stateCompo' :template='template'
                   :components='components' :maxState='maxState')
  slot(name='default')
</template>
<script setup>

import PugEditor from './PugEditor.vue';
import { computed, nextTick, ref, useSlots, watch } from 'vue';
import StateComponent from './StateComponent.vue';

const slots = useSlots();

const props = defineProps({
  title: { type: String, default: '' },
  maxState: { type: Number, default: 3 },
  components: { type: Object, default: () => ({}) }
});

const showCode = ref(false);
const showInterface = ref(false);
const hasFocus = ref(false);
const template = ref('<div></div>');

/** @type {V.Ref<InstanceType<typeof PugEditor>|null>} */
const pugEditor = ref(null);
/** @type {V.Ref<InstanceType<typeof StateComponent>|null>} */
const stateCompo = ref(null);

const isSelected = computed(() => false);//query && (query.anchor === props.title));

watch(showCode,
  () => nextTick(() => pugEditor.value?.refresh()));

/**
 * @param {string} name
 */
 function hasSlot(name) {
  return !!slots?.[name];
}

function setSelected() {
  // if (this.isSelected) {
  //   this.$router.push({ query: {} });
  // }
  // else {
  //   this.$router.push({ query: { anchor: this.title } });
  // }
}

</script>
<style lang='scss'>
.card.x-example {
  transition: width 250ms, height 250ms;
  &.selected {
    box-shadow: 0 1rem 3rem rgba(0, 0, 0, 0.175) !important;
    display: block !important;
    position: fixed !important;
    margin: 50px;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    z-index: 1050;

    > ul {
      overflow-y: auto;
      max-height: 95%;
    }
  }
}
</style>
